-#!/usr/bin/perl
+#!/usr/bin/env perl
+#
use strict;
use warnings;
-use CSS::Minifier::XS;
+
+use CSS::Minifier::XS 0.07;
use File::Copy;
use File::Find;
+use File::Path qw(make_path);
use File::Slurp;
use File::Spec;
use Getopt::Long;
use JavaScript::Minifier::XS;
+use Pod::Usage;
use XML::LibXML;
use XML::LibXSLT;
## Add the exim-html-current symlink
print "Symlinking exim-html-current to exim-html-$opt{latest}\n";
-symlink( "$opt{docroot}/exim-html-$opt{latest}", "$opt{docroot}/exim-html-current" );
+unlink("$opt{docroot}/exim-html-current") if ( -l "$opt{docroot}/exim-html-current" );
+symlink( "exim-html-$opt{latest}", "$opt{docroot}/exim-html-current" )
+ || die "symlink to $opt{docroot}/exim-html-current failed";
## Generate the website files
sub do_web {
## Build HTML from XSL files and simply copy static files which have changed
if ( $path =~ /(.+)\.xsl$/ ) {
- print "Generating : docroot:/$1.html\n";
+ print "Generating : docroot:/$1.html\n" if ($opt{verbose});
transform( undef, "$opt{tmpl}/web/$path", "$opt{docroot}/$1.html" );
}
elsif ( -f "$opt{tmpl}/web/$path" ) {
return if -f "$opt{docroot}/$path" && ( stat("$opt{tmpl}/web/$path") )[9] == ( stat("$opt{docroot}/$path") )[9];
if ( $path =~ /(.+)\.css$/ ) {
- print "CSS to : docroot:/$path\n";
+ print "CSS to : docroot:/$path\n" if ($opt{verbose});
my $content = read_file("$opt{tmpl}/web/$path");
write_file( "$opt{docroot}/$path", $opt{minify} ? CSS::Minifier::XS::minify($content) : $content );
}
elsif ( $path =~ /(.+)\.js$/ ) {
- print "JS to : docroot:/$path\n";
+ print "JS to : docroot:/$path\n" if ($opt{verbose});
my $content = read_file("$opt{tmpl}/web/$path");
write_file( "$opt{docroot}/$path", $opt{minify} ? JavaScript::Minifier::XS::minify($content) : $content );
}
else {
## Copy
- print "Copying to : docroot:/$path\n";
+ print "Copying to : docroot:/$path\n" if ($opt{verbose});
copy( "$opt{tmpl}/web/$path", "$opt{docroot}/$path" ) or die "$path: $!";
}
## Set mtime
## Generate a Table of Contents XML file
{
my $path = "exim-html-$version/doc/html/spec_html/" . ( $type eq 'filter' ? 'filter_toc' : 'index_toc' ) . ".xml";
- print "Generating : docroot:/$path\n";
+ print "Generating : docroot:/$path\n" if ($opt{verbose});
transform( $xml, "$opt{tmpl}/doc/toc.xsl", "$opt{docroot}/$path", );
}
## Transform the chapter into html
{
my $path = sprintf( 'exim-html-%s/doc/html/spec_html/%sch%02d.html', $version, $prepend_chapter, $counter );
- print "Generating : docroot:/$path\n";
+ print "Generating : docroot:/$path\n" if ($opt{verbose});
transform( $doc, "$opt{tmpl}/doc/chapter.xsl", "$opt{docroot}/$path", );
}
}
foreach my $role ( sort { $a cmp $b } keys %{$index_hash} ) {
my $chapter = XML::LibXML::Element->new('chapter');
$book->appendChild($chapter);
- $chapter->setAttribute( 'id', 'index_' . $role );
+ $chapter->setAttribute( 'id', join( '_', 'index', $role ) );
+ $chapter->setAttribute( 'class', 'index' );
$chapter->appendTextChild( 'title', ( ucfirst($role) . ' Index' ) );
foreach my $first ( sort { $a cmp $b } keys %{ $index_hash->{$role} } ) {
my $section = XML::LibXML::Element->new('section');
my $list = XML::LibXML::Element->new('variablelist');
$chapter->appendChild($section);
- $section->setAttribute( 'id', 'index_' . $role . '_' . $first );
+ $section->setAttribute( 'id', join( '_', 'index', $role, $first ) );
+ $section->setAttribute( 'class', 'index' );
$section->appendTextChild( 'title', $first ? $first : 'Symbols' );
$section->appendChild($list);
foreach my $primary ( sort { $a cmp $b } keys %{ $index_hash->{$role}{$first} } ) {
my $doc = $stylesheet->transform($xml);
## Make the containing directory if it doesn't exist
- mkdirp( ( $out_path =~ /^(.+)\/.+$/ )[0] );
+ make_path( ( $out_path =~ /^(.+)\/.+$/ )[0], { verbose => 1 } );
## Write out the document
- open my $out, '>', $out_path or die $!;
+ open my $out, '>', $out_path or die "Unable to write $out_path - $!";
print $out $stylesheet->output_as_bytes($doc);
close $out;
}
-## "mkdir -p "
-sub mkdirp {
- my $path = shift;
-
- my @parts = ();
- foreach ( split( /\//, $path ) ) {
- push @parts, $_;
- my $make = join( '/', @parts );
- next unless length($make);
- next if -d $make;
- mkdir($make) or die "Unable to mkdir $make: $!\n";
- }
+## error_help
+sub error_help {
+ my $msg = shift;
+
+ warn $msg;
+ pod2usage( -exitval => 1, -verbose => 0 );
}
## Parse arguments
sub parse_arguments {
- my %opt = ( spec => [], filter => [], help => 0, web => 0, minify => 1 );
- GetOptions( \%opt, 'help|h!', 'web!', 'spec=s{1,}', 'filter=s{1,}', 'latest=s', 'tmpl=s', 'docroot=s', 'minify!' )
- || help( 1, 'Bad options' );
+ my %opt = ( spec => [], filter => [], help => 0, man => 0, web => 0, minify => 1, verbose => 0 );
+ GetOptions( \%opt, 'help|h!', 'man!', 'web!', 'spec=s{1,}', 'filter=s{1,}', 'latest=s', 'tmpl=s', 'docroot=s', 'minify!', 'verbose!' )
+ || pod2usage( -exitval => 1, -verbose => 0 );
## --help
- help(0) if ( $opt{help} );
+ pod2usage(0) if ( $opt{help} );
+ pod2usage( -verbose => 2 ) if ( $opt{man} );
## --spec and --filter lists
foreach my $set (qw[spec filter]) {
$opt{$set} = [ map { my $f = File::Spec->rel2abs($_); help( 1, 'No such file: ' . $_ ) unless -f $f; $f } @{ $opt{$set} } ];
}
## --latest
- help( 1, 'Missing value for latest' ) unless ( exists( $opt{latest} ) && defined( $opt{latest} ) );
- help( 1, 'Invalid value for latest' ) unless $opt{latest} =~ /^\d+(?:\.\d+)*$/;
+ error_help('Missing value for latest') unless ( exists( $opt{latest} ) && defined( $opt{latest} ) );
+ error_help('Invalid value for latest') unless $opt{latest} =~ /^\d+(?:\.\d+)*$/;
## --tmpl and --docroot
foreach my $set (qw[tmpl docroot]) {
- help( 1, 'Missing value for ' . $set ) unless ( exists( $opt{$set} ) && defined( $opt{$set} ) );
+ error_help( 'Missing value for ' . $set ) unless ( exists( $opt{$set} ) && defined( $opt{$set} ) );
my $f = File::Spec->rel2abs( $opt{$set} );
- help( 1, 'No such directory: ' . $opt{$set} ) unless -d $f;
+ error_help( 'No such directory: ' . $opt{$set} ) unless -d $f;
$opt{$set} = $f;
}
- help( 1, 'Excess arguments' ) if ( scalar(@ARGV) );
+ error_help('Excess arguments') if ( scalar(@ARGV) );
- help( 1, 'Must include at least one of --web, --spec or --filter' )
- unless ( defined $opt{web} || scalar( @{ $opt{spec} } ) || scalar( @{ $opt{web} } ) );
+ error_help('Must include at least one of --web, --spec or --filter')
+ unless ( $opt{web} || scalar( @{ $opt{spec} || [] } ) || scalar( @{ $opt{filter} || [] } ) );
return %opt;
}
-## Help information
-sub help {
- my ( $exit_code, $msg ) = @_;
+1;
- print "$msg\n\n" if defined $msg;
+__END__
- print << "END_HELP";
-Options:
- --help or -h : Print this help information and then exit
+=head1 NAME
- --web : Generate the general website pages
- --spec PATH : Generate the spec pages. PATH is the path to the spec.xml
- --filter PATH : Generate the filter pages. PATH is the path to the filter.xml
+gen.pl - Generate exim html documentation and website
- One or more of the above three options are required. --spec and --filter can
- take multiple values to generate different sets of documentation for
- different versions at the same time.
+=head1 SYNOPSIS
- --latest VERSION : Required. Specify the latest stable version of Exim.
- --tmpl PATH : Required. Path to the templates directory
- --docroot PATH : Required. Path to the website document root
+gen.pl [options]
- If CSS::Minifier::XS is installed, then CSS will be minified.
- If JavaScript::Minifier::XS is installed, then JavaScript will be minified.
+ Options:
+ --help display this help and exits
+ --man displays man page
+ --spec file... spec docbook/XML source files
+ --filter file... filter docbook/XML source files
+ --web Generate the general website pages
+ --latest VERSION Required. Specify the latest stable version of Exim.
+ --tmpl PATH Required. Path to the templates directory
+ --docroot PATH Required. Path to the website document root
+ --[no-]minify [Don't] minify CSS and Javascript
-Example:
+=head1 OPTIONS
- ./gen.pl --latest 4.72
- --web
- --spec spec.xml 4.71/spec.xml
- --filter filter.xml 4.71/filter.xml
- --tmpl ~/www/templates
- --docroot ~/www/docroot
-END_HELP
+=over 4
+
+=item B<--help>
+
+Display help and exits
+
+=item B<--man>
+
+Display man page
+
+=item B<--spec> I<file...>
+
+List of files that make up the specification documentation
+docbook/XML source files.
+
+=item B<--filter> I<file...>
+
+List of files that make up the filter documentation docbook/XML
+source files.
+
+=item B<--web>
+
+Generate the website from the template files.
+
+=item B<--latest> I<version>
+
+Specify the current exim version. This is used to create links to
+the current documentation.
+
+This option is I<required>
+
+=item B<--tmpl> I<directory>
+
+Specify the directory that the templates are kept in.
+
+This option is I<required>
+
+=item B<--docroot> I<directory>
+
+Specify the directory that the output should be generated into.
+This is the website C<docroot> directory.
+
+This option is I<required>
+
+=item B<--minify>
+
+If this option is set then both the CSS and Javascript files
+processed are minified using L<CSS::Minifier::XS> and
+L<JavaScript::Minifier::XS> respectively.
+
+This option is set by default - to disable it specify C<--no-minify>
+
+=back
+
+=head1 DESCRIPTION
+
+Generates the exim website and HTML documentation.
+
+=head1 EXAMPLE
+
+ script/gen.pl \
+ --web \
+ --spec docbook/*/spec.xml \
+ --filter docbook/*/filter.xml \
+ --latest 4.72 \
+ --tmpl templates \
+ --docroot /tmp/website
+
+=head1 AUTHOR
+
+Mike Cardwell
+
+Nigel Metheringham <nigel@exim.org> - mostly broke the framework
+Mike produced.
+
+=head1 COPYRIGHT
+
+Copyright 2010 Exim Maintainers. All rights reserved.
+
+=cut
- exit($exit_code);
-}